-- =======================================================================
--                             Along The River
-- =======================================================================

-- =======================================================================
--                                 Player 1
-- =======================================================================
p1:allow_buildings("all")
p1:forbid_buildings{"shipyard"}

prefilled_buildings(p1,
	{ "headquarters_interim", 15, 119,
		wares = {
			trunk = 80,
			blackwood = 32,
			raw_stone = 40,
			grout = 12,
			thatchreed = 24,
			cloth = 5,
			coal = 12,
			ironore = 5,
			iron = 12,
			gold = 8,
			fish = 6,
			meat = 6,
			pittabread = 8,
			ration = 12,
			snack = 3,
			meal = 4,
			pick = 14,
			shovel = 4,
			felling_axe = 4,
			fishing_rod = 3,
			hunting_spear = 3,
			scythe = 6,
			hammer = 12,
			fire_tongs = 2,
			bakingtray = 2,
			kitchen_tools = 4,
			axe = 6,
		},
		workers = {
			carrier = 40,
			ox = 20,
			stonemason = 2,
			lumberjack = 4,
			ranger = 2,
			fisher = 2,
			builder = 10,
			brewer = 1,
			blacksmith = 2,
			geologist = 6,
			miner = 4,
		},
		soldiers = { [{0,0,0,0}] = 30 }
	},
	{ "sentry", 22, 101, soldiers = { [{0,0,0,0}] = 2 }},
	{ "sentry", 27, 128, soldiers = { [{0,0,0,0}] = 2 }},
	{ "scouts_hut", 23, 103, wares = {ration = 2} },
	{ "scouts_hut", 28, 129, wares = {ration = 2} },

	{ "battlearena", 12, 119, wares = {pittabread = 10, fish = 6, meat = 6} },
	{ "trainingscamp", 14, 115, wares = {pittabread = 10, fish = 6, meat = 6} },
	{ "helmsmithy", 16, 111, wares = {iron = 8, gold = 8, coal = 8} },

	{ "well", 16, 117},
	{ "metalworks", 17, 115, wares = {iron = 8, trunk = 8} },
	{ "smelting_works", 18, 113, wares = {ironore = 8, goldstone = 8, coal = 8} },
	{ "barrier", 19, 111, soldiers = { [{0,0,0,0}] = 5 }},
	{ "fernery", 20, 109},

	{ "hardener", 17, 119, wares = {trunk = 8} },
	{ "lime_kiln", 18, 117, wares = {raw_stone = 6, water= 6, coal = 3} },
	{ "axefactory", 19, 115, wares = {iron = 8, coal = 8} }
)

-- =======================================================================
--                                 Player 2
-- =======================================================================
p2:forbid_buildings("all")
p2:allow_buildings{
	"deep_coalmine",
	"deeper_coalmine",
	"deep_oremine",
	"deeper_oremine",
	"deep_goldmine",
	"deeper_goldmine",
	"quarry",
	"lumberjacks_hut",
	"rangers_hut",
	"fishers_hut",
	"hunters_hut",
	"gamekeepers_hut",
	"well",
	"warehouse",
	"hardener",
	"lime_kiln",
	"fernery",
	"bakery",
	"micro-brewery",
	"brewery",
	"tavern",
	"inn",
	"big_inn",
	"burners_house",
	"smelting_works",
	"metalworks",
	"axefactory",
	"warmill",
	"cattlefarm",
	"farm",
	"helmsmithy",
	"trainingscamp"
}

prefilled_buildings(p2,
	{ "headquarters_interim", 33, 17,
		wares = {
			trunk = 80,
			blackwood = 32,
			raw_stone = 40,
			grout = 12,
			thatchreed = 24,
			coal = 12,
			ironore = 5,
			iron = 12,
			gold = 8,
			fish = 6,
			meat = 6,
			pittabread = 8,
			ration = 12,
			snack = 3,
			meal = 4,
			pick = 14,
			shovel = 4,
			fishing_rod = 3,
			hunting_spear = 2,
			scythe = 6,
			hammer = 12,
			fire_tongs = 2,
			bakingtray = 2,
			kitchen_tools = 4,
			axe = 6,
		},
		workers = {
			carrier = 40,
			ox = 20,
			stonemason = 2,
			lumberjack = 3,
			ranger = 1,
			fisher = 2,
			builder = 10,
			["lime-burner"] = 1,
			ferner = 1,
			brewer = 1,
			blacksmith = 2,
			geologist = 8,
			miner = 4
		}
	},
	{ "warehouse", 26, 59,
		wares = {trunk = 20,blackwood=20,raw_stone=10,grout=5,thatchreed=5},
		workers = {
			carrier = 40,
			ox			= 20,
			builder = 4
	}},
	{ "warehouse", 30, 14	},
	{ "warehouse", 39, 16	},
	{ "fortress", 27, 76, soldiers = { [{1,1,0,0}] = 1 }},
	{ "barrier",  21, 81, soldiers = { [{1,1,0,0}] = 1 }},
	{ "barrier",  22, 74, soldiers = { [{1,1,0,0}] = 1 }},
	{ "barrier",  24, 60, soldiers = { [{1,1,0,0}] = 1 }},
	{ "barrier",  32, 56, soldiers = { [{1,1,0,0}] = 1 }},
	{ "barrier",  35, 54, soldiers = { [{1,1,0,0}] = 1 }},
	{ "barrier",  32, 46, soldiers = { [{1,1,0,0}] = 1 }},
	{ "sentry",   24, 81, soldiers = { [{1,1,0,0}] = 1 }},
	{ "sentry",   22, 63, soldiers = { [{1,1,0,0}] = 1 }},
	{ "donjon",   25, 69, soldiers = { [{1,1,0,0}] = 1 }},
	{ "fortress", 29, 59, soldiers = { [{1,1,0,0}] = 1 }},
	{ "citadel",  33, 50, soldiers = { [{1,1,0,0}] = 1 }},

	{ "barrier",  40, 50, soldiers = { [{1,1,0,0}] = 1 }},
	{ "fortress", 50, 41, soldiers = { [{1,1,0,0}] = 1 }},
	{ "fortress", 53, 30, soldiers = { [{1,1,0,0}] = 1 }},
	{ "barrier",  43, 33, soldiers = { [{1,1,0,0}] = 1 }},
	{ "fortress", 35, 31, soldiers = { [{1,1,0,0}] = 1 }},
	{ "barrier",  28, 28, soldiers = { [{1,1,0,0}] = 1 }},
	{ "fortress", 25, 18, soldiers = { [{1,1,0,0}] = 1 }},
	{ "barrier",  30, 10, soldiers = { [{1,1,0,0}] = 1 }},
	{ "fortress", 42, 17, soldiers = { [{1,1,0,0}] = 1 }},

	{ "rangers_hut", 31, 17 },
	{ "rangers_hut", 28, 64 },
	{ "rangers_hut", 21, 66 },

	{ "oremine", 19, 21, wares = { ration = 6 }},
	{ "coalmine", 21, 15, wares = { ration = 6 }},
	{ "coalmine", 20, 13, wares = { ration = 6 }},
	{ "goldmine", 23, 11, wares = { ration = 6 }},
	{ "granitemine", 26, 7, wares = { ration = 8 }},
	{ "granitemine", 30, 4, wares = { ration = 8 }}
)

-- =======================================================================
--                                 Player 4
-- =======================================================================
p4:forbid_buildings("all")
p4:allow_buildings{
	"deep_coalmine",
	"deeper_coalmine",
	"deep_oremine",
	"deeper_oremine",
	"deep_goldmine",
	"deeper_goldmine",
	"quarry",
	"lumberjacks_hut",
	"rangers_hut",
	"fishers_hut",
	"hunters_hut",
	"gamekeepers_hut",
	"well",
	"warehouse",
	"hardener",
	"lime_kiln",
	"fernery",
	"bakery",
	"micro-brewery",
	"brewery",
	"tavern",
	"inn",
	"big_inn",
	"burners_house",
	"smelting_works",
	"metalworks",
	"axefactory",
	"warmill",
	"cattlefarm",
	"farm",
	"helmsmithy",
	"battlearena",
	"trainingscamp"
}

-- Room for mines.
p4:conquer(wl.Game().map:get_field(107, 60), 3)
p4:conquer(wl.Game().map:get_field(105, 63), 3)

prefilled_buildings(p4,
	{ "headquarters_interim", 102, 36,
		wares = {
			trunk = 80,
			blackwood = 32,
			raw_stone = 40,
			grout = 12,
			thatchreed = 24,
			coal = 12,
			ironore = 6,
			iron = 12,
			goldstone = 5,
			gold = 8,
			fish = 6,
			meat = 6,
			pittabread = 8,
			pick = 14,
			shovel = 4,
			felling_axe = 4,
			fishing_rod = 2,
			hunting_spear = 2,
			scythe = 6,
			hammer = 12,
			fire_tongs = 2,
			bakingtray = 2,
			kitchen_tools = 4,
			axe = 6,
		},
		workers = {
			carrier = 40,
			ox = 20,
			stonemason = 2,
			lumberjack = 3,
			ranger = 1,
			fisher = 2,
			builder = 10,
			["lime-burner"] = 1,
			ferner = 1,
			brewer = 1,
			["master-brewer"] = 1,
			blacksmith = 2,
			["master-blacksmith"] = 1,
			geologist = 6,
			miner = 4,
		}
	},

	{ "warehouse", 112, 30,
		wares = {trunk = 80,blackwood=40,raw_stone=40,grout=20,thatchreed=25},
		workers = {
			carrier = 40,
			ox			= 20,
			builder = 4
	}},

	{ "warehouse", 97, 23,
		wares = {trunk = 80,blackwood=40,raw_stone=40,grout=20,thatchreed=25},
		workers = {
			carrier = 40,
			ox			= 20,
			builder = 4
	}},

	{ "coalmine", 			105,  63, wares = {ration = 6 }},
	{ "coalmine", 			107,  60, wares = {ration = 6 }},
	{ "oremine",				109,  57, wares = {ration = 6 }},
	{ "oremine",				112,  56, wares = {ration = 6 }},
	{ "granitemine",		115,  50, wares = {ration = 8 }},
	{ "granitemine",		117,  46, wares = {ration = 8 }},
	{ "goldmine", 			 81,   0, wares = {ration = 6 }},
	{ "barrier", 	106,  50, soldiers = { [{2,3,0,0}] = 1 }},	-- close to black
	{ "sentry", 	102,  48, soldiers = { [{2,3,0,0}] = 1 }},	-- close to black
	{ "fortress", 110,  48, soldiers = { [{2,3,0,0}] = 1 }},
	{ "barrier",   96,  36, soldiers = { [{2,3,0,0}] = 1 }},	-- close to black
	{ "fortress", 119,  30, soldiers = { [{2,3,0,0}] = 1 }},
	{ "fortress", 129,  20, soldiers = { [{2,3,0,0}] = 1 }},
	{ "fortress", 138,  20, soldiers = { [{2,3,0,0}] = 1 }},
	{ "fortress",  99,  12, soldiers = { [{2,3,0,0}] = 1 }},
	{ "fortress", 114,  40, soldiers = { [{2,3,0,0}] = 1 }},
	{ "barrier", 	 91,  14, soldiers = { [{2,3,0,0}] = 1 }},
	{ "fortress",	103,  22, soldiers = { [{2,3,0,0}] = 1 }},
	{ "sentry", 	 93,  22, soldiers = { [{2,3,0,0}] = 1 }},
	{ "barrier", 	 83,   8, soldiers = { [{2,3,0,0}] = 1 }},
	{ "barrier", 	 76,   2, soldiers = { [{2,3,0,0}] = 1 }}
)

-- =======================================================================
--                                 Player 5
-- =======================================================================

p5:forbid_buildings("all")
p5:allow_buildings{
	"fishers_hut",
	"hunters_hut",
	"gamekeepers_hut",
	"well"
}

prefilled_buildings(p5,
	{ "headquarters_interim", 87, 65,
		wares = {
			trunk = 80,
			raw_stone = 40,
			hammer = 3,
			shovel = 5,
			felling_axe = 5,
			fishing_rod = 7,
			hunting_spear = 5
		},
		workers = {
			carrier = 70,
			ox = 5
		}
	},

	{ "headquarters_interim", 134, 65,
		wares = {
			trunk = 80,
			raw_stone = 40,
			hammer = 3,
			shovel = 5,
			felling_axe = 5,
			fishing_rod = 7,
			hunting_spear = 5
		},
		workers = {
			carrier = 70,
			ox = 5
		}
	},

	{ "tavern", 92, 72 },
	{ "tavern", 128, 66 },

	{ "lumberjacks_hut", 134, 56 },
	{ "rangers_hut", 135, 54 },

	{ "fishers_hut", 82, 60 },
	{ "fishers_hut", 78, 65 },
	{ "fishers_hut", 72, 70 },
	{ "fishers_hut", 128, 73 },
	{ "fishers_hut", 138, 68 },
	{ "fishers_hut", 141, 52 },
	{ "fishers_hut", 100, 96 },

	{ "hunters_hut", 93, 66 },
	{ "hunters_hut", 84, 69 },
	{ "hunters_hut", 83, 93 },
	{ "hunters_hut", 78, 73 },
	{ "hunters_hut", 77, 89 },
	{ "hunters_hut", 68, 88 },
	{ "hunters_hut", 102, 93 },
	{ "hunters_hut", 115, 85 },
	{ "hunters_hut", 132, 62 },

	{ "gamekeepers_hut", 93, 70 },
	{ "gamekeepers_hut", 86, 70 },
	{ "gamekeepers_hut", 85, 92 },
	{ "gamekeepers_hut", 79, 70 },
	{ "gamekeepers_hut", 78, 85 },
	{ "gamekeepers_hut", 70, 89 },
	{ "gamekeepers_hut", 105, 91 },
	{ "gamekeepers_hut", 119, 80 },
	{ "gamekeepers_hut", 134, 61 },

	{ "fortress", 55,  60, soldiers = { [{0,2,0,2}] = 4 }},	-- Must match with soldier level in init
	{ "sentry",  	96,  65, soldiers = { [{0,1,0,2}] = 1 }},	-- close to green
	{ "sentry",  	90,  63, soldiers = { [{0,1,0,2}] = 1 }},	-- close to green
	{ "fortress", 88,  71, soldiers = { [{0,1,0,2}] = 1 }},
	{ "barrier",  80,  77, soldiers = { [{0,1,0,2}] = 1 }},	-- dism.
	{ "barrier",  88,  91, soldiers = { [{0,1,0,2}] = 1 }},
	{ "barrier",  91,  80, soldiers = { [{0,1,0,2}] = 1 }}, -- dism.
	{ "fortress", 124,  76, soldiers = { [{0,1,0,2}] = 1 }},
	{ "fortress", 132,  68, soldiers = { [{0,1,0,2}] = 1 }},
	{ "fortress", 137,  55, soldiers = { [{0,1,0,2}] = 1 }},
	{ "sentry",		 81,  63, soldiers = { [{0,1,0,2}] = 1 }},	-- beneath lake
	{ "sentry",		 76,  68, soldiers = { [{0,1,0,2}] = 1 }},	-- beneath lake

	{ "sentry",		 75,  98, soldiers = { [{0,1,0,2}] = 1 }},	-- close to brook

	{ "sentry",  	 68,  71, soldiers = { [{0,1,0,2}] = 1 }},
	{ "donjon",    66,  80, soldiers = { [{0,1,0,2}] = 1 }},	-- close to border
	{ "fortress",  72,  87, soldiers = { [{0,1,0,2}] = 1 }},	-- close to border

	{ "barrier",		 82, 103, soldiers = { [{0,1,0,2}] = 1 }},	-- along river
	{ "barrier",		 96,  94, soldiers = { [{0,1,0,2}] = 1 }},
	{ "stronghold",	100,  80, soldiers = { [{0,1,0,2}] = 1 }},
	{ "stronghold",	101,  89, soldiers = { [{0,1,0,2}] = 1 }},
	{ "sentry",			107,  88, soldiers = { [{0,1,0,2}] = 1 }},
	{ "stronghold",	110,  84, soldiers = { [{0,1,0,2}] = 1 }},
	{ "stronghold",	115,  80, soldiers = { [{0,1,0,2}] = 1 }},

	{ "sentry",   59,   89, soldiers = { [{0,2,0,2}] = 2 }}		-- in front of the brook
)

-- =======================================================================
--                                 Player 3
-- =======================================================================
p3:forbid_buildings("all")
p3:allow_buildings{
	"granitemine",
	"coalmine",
	"deep_coalmine",
	"deeper_coalmine",
	"oremine",
	"deep_oremine",
	"deeper_oremine",
	"goldmine",
	"deep_goldmine",
	"deeper_goldmine",
	"quarry",
	"lumberjacks_hut",
	"rangers_hut",
	"fishers_hut",
	"hunters_hut",
	"gamekeepers_hut",
	"well",
	"warehouse",
	"hardener",
	"lime_kiln",
	"fernery",
	"bakery",
	"micro-brewery",
	"brewery",
	"tavern",
	"inn",
	"big_inn",
	"burners_house",
	"smelting_works",
	"metalworks",
	"axefactory",
	"warmill",
	"cattlefarm",
	"farm",
	"helmsmithy",
	"battlearena",
	"trainingscamp"
}

-- Room for donjon after Hjalmar defeated.
p3:conquer(wl.Game().map:get_field(116, 19), 2)

prefilled_buildings(p3,
	{ "headquarters_interim", 123, 119,
		wares = {
			trunk = 80,
			blackwood = 32,
			raw_stone = 40,
			grout = 12,
			thatchreed = 24,
			coal = 120,
			ironore = 60,
			iron = 12,
			goldstone = 50,
			gold = 8,
			fish = 6,
			meat = 6,
			pittabread = 8,
			ration = 12,
			snack = 3,
			meal = 4,
			pick = 14,
			shovel = 4,
			felling_axe = 4,
			fishing_rod = 2,
			hunting_spear = 2,
			scythe = 6,
			hammer = 12,
			fire_tongs = 2,
			bakingtray = 2,
			kitchen_tools = 4,
			axe = 6
		},
		workers = {
			carrier = 40,
			ox = 20,
			stonemason = 2,
			lumberjack = 3,
			ranger = 1,
			fisher = 2,
			builder = 10,
			["lime-burner"] = 1,
			ferner = 1,
			brewer = 1,
			["master-brewer"] = 1,
			blacksmith = 2,
			["master-blacksmith"] = 1,
			geologist = 6,
			miner = 4
		}
	},

	{ "citadel", 				109, 106, soldiers = { [{2,3,0,2}] = 1 }},	-- front with p5
	{ "citadel", 				114, 105, soldiers = { [{2,3,0,2}] = 1 }},
	{ "citadel", 				118, 101, soldiers = { [{2,3,0,2}] = 1 }},
	{ "citadel", 				121,  97, soldiers = { [{2,3,0,2}] = 1 }},

	{ "citadel", 				130, 118, soldiers = { [{2,3,0,2}] = 1 }},
	{ "citadel", 				129, 133, soldiers = { [{2,3,0,2}] = 1 }},
	{ "fortress", 			105, 114, soldiers = { [{2,3,0,2}] = 1 }},
	{ "fortress", 			131, 108, soldiers = { [{2,3,0,2}] = 1 }},
	{ "fortress", 			127,  96, soldiers = { [{2,3,0,2}] = 1 }},
	{ "barrier", 				118, 123, soldiers = { [{2,3,0,2}] = 1 }},
	{ "citadel", 				122, 136, soldiers = { [{2,3,0,2}] = 1 }},
	{ "citadel", 				 87, 131, soldiers = { [{2,3,0,2}] = 1 }},
	{ "fortress", 			134,  95, soldiers = { [{2,3,0,2}] = 1 }},

	{ "barrier", 				 95, 131, soldiers = { [{2,3,0,2}] = 1 }},	-- around smelting works
	{ "citadel", 				101, 131, soldiers = { [{2,3,0,2}] = 1 }},
	{ "citadel", 				117, 140, soldiers = { [{2,3,0,2}] = 1 }},
	{ "barrier", 				106, 138, soldiers = { [{2,3,0,2}] = 1 }},
	{ "barrier", 				111, 140, soldiers = { [{2,3,0,2}] = 1 }},
	{ "sentry", 				100, 123, soldiers = { [{2,3,0,2}] = 1 }},

	{ "rangers_hut", 		104, 134 },
	{ "rangers_hut", 		112, 138 },

	{ "helmsmithy", 		115, 142, wares = {iron = 8, gold = 8, coal = 8} },
	{ "helmsmithy", 		100, 128, wares = {iron = 8, gold = 8, coal = 8} },

	{ "big_inn", 				106, 130, wares = {fish = 4, meat = 4, pittabread = 4, beer = 4, strongbeer = 4} },
	{ "big_inn", 				108, 130, wares = {fish = 4, meat = 4, pittabread = 4, beer = 4, strongbeer = 4} },
	{ "big_inn", 				108, 138, wares = {fish = 4, meat = 4, pittabread = 4, beer = 4, strongbeer = 4} },
	{ "big_inn", 				110, 138, wares = {fish = 4, meat = 4, pittabread = 4, beer = 4, strongbeer = 4} },

	{ "smelting_works", 105, 132, wares = {ironore = 8, goldstone = 8, coal = 8} },
	{ "smelting_works", 107, 132, wares = {ironore = 8, goldstone = 8, coal = 8} },
	{ "smelting_works", 109, 132, wares = {ironore = 8, goldstone = 8, coal = 8} },
	{ "smelting_works", 111, 132, wares = {ironore = 8, goldstone = 8, coal = 8} },

	{ "warmill", 				106, 134, wares = {iron = 8, gold = 8, coal = 8} },
	{ "warmill", 				108, 134, wares = {iron = 8, gold = 8, coal = 8} },
	{ "warmill", 				110, 134, wares = {iron = 8, gold = 8, coal = 8} },
	{ "warmill", 				112, 134, wares = {iron = 8, gold = 8, coal = 8} },

	{ "metalworks", 		107, 136, wares = {iron = 8, trunk = 8} },
	{ "warehouse", 			109, 136, workers = {carrier = 40, ox = 20} },
	{ "metalworks", 		111, 136, wares = {iron = 8, trunk = 8} },

	{ "sentry", 				110,   3, soldiers = { [{2,3,0,2}] = 1 }},	-- path through mountains
	{ "citadel", 				113,   7, soldiers = { [{2,3,0,2}] = 1 }},
	{ "barrier", 				115,  10, soldiers = { [{2,3,0,2}] = 1 }},

	{ "warehouse", 			129, 101, workers = {carrier = 40, ox = 20} },
	{ "warehouse", 			114, 113, workers = {carrier = 40, ox = 20} },
	{ "warehouse", 			 94, 124, workers = {carrier = 40, ox = 20} }
)
